.386
.model flat,stdcall
option casemap:none

include windows.inc
include user32.inc
include kernel32.inc
include shell32.inc
include comctl32.inc
include comdlg32.inc

includelib user32.lib
includelib kernel32.lib
includelib shell32.lib
includelib comctl32.lib
includelib comdlg32.lib

include masm32.inc
includelib masm32.lib

include e:\RadASM\masm\inc\debug.inc			;used for VKim Debug
include e:\RadASM\masm\inc\radbg.inc			;Used for RadASM Debug
includelib e:\RadASM\masm\lib\debug.lib		;used for VKim Debug

WinMain				PROTO :DWORD,:DWORD,:DWORD,:DWORD
WndProc				PROTO :DWORD,:DWORD,:DWORD,:DWORD

IDD_DIALOG						equ 1000
IDC_STC9						equ 1002
IDC_CBO1						equ 1012
IDC_STC19						equ 1022

.const

ClassName			db 'DLGCLASS',0
AppName				db 'Dialog as main',0
AboutMsg			db 'MASM32 RadASM Dialog as main',13,10,'Copyright  MASM32 2001',0
CrLf				db 10,13,0
GotItStatic			db 'Detected Label',0
GotItCombo			db 'Detected Combo',0

.data?

hInstance			dd ?
hWnd				dd ?
hIDC_STC9			dd ?
hIDC_STC19			dd ?
hIDC_CBO1			dd ?

.code

start:

	invoke GetModuleHandle,NULL
	mov    hInstance,eax
	invoke InitCommonControls
	invoke WinMain,hInstance,NULL,NULL,SW_SHOWDEFAULT
	invoke ExitProcess,eax

WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL	wc:WNDCLASSEX
	LOCAL	msg:MSG

	mov		wc.cbSize,sizeof WNDCLASSEX
	mov		wc.style,CS_HREDRAW or CS_VREDRAW
	mov		wc.lpfnWndProc,offset WndProc
	mov		wc.cbClsExtra,NULL
	mov		wc.cbWndExtra,DLGWINDOWEXTRA
	push	hInst
	pop		wc.hInstance
	mov		wc.hbrBackground,COLOR_BTNFACE+1
	mov		wc.lpszMenuName,NULL
	mov		wc.lpszClassName,offset ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov		wc.hIcon,eax
	mov		wc.hIconSm,eax
	invoke LoadCursor,NULL,IDC_ARROW
	mov		wc.hCursor,eax
	invoke RegisterClassEx,addr wc
	invoke CreateDialogParam,hInstance,IDD_DIALOG,NULL,addr WndProc,NULL
	invoke ShowWindow,hWnd,SW_SHOWNORMAL
	invoke UpdateWindow,hWnd
	.while TRUE
		invoke GetMessage,addr msg,NULL,0,0
	  .BREAK .if !eax
		invoke TranslateMessage,addr msg
		invoke DispatchMessage,addr msg
	.endw
	mov		eax,msg.wParam
	ret

WinMain endp

WndProc proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL flgFound:DWORD
LOCAL rect:RECT
LOCAL pt:POINT

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		push	hWin
		pop		hWnd
		
		invoke GetDlgItem,hWnd,IDC_STC19
		mov hIDC_STC19, eax
		
 		invoke GetDlgItem,hWnd,IDC_STC9
		mov hIDC_STC9, eax

 		invoke GetDlgItem,hWnd,IDC_CBO1
		mov hIDC_CBO1, eax

	.elseif eax==WM_COMMAND
		mov		eax,wParam
		and		eax,0FFFFh

	.elseif eax == WM_MOUSEMOVE
		mov flgFound,0
		invoke GetCursorPos, addr pt
	   	invoke GetWindowRect, hIDC_STC9, addr rect
		invoke PtInRect, addr rect, pt.x, pt.y
        .if (eax)
        	invoke SendMessage,hIDC_STC19,WM_SETTEXT,0,ADDR GotItStatic
        	inc flgFound
		.else
			invoke GetWindowRect, hIDC_CBO1, addr rect
			invoke PtInRect, addr rect, pt.x, pt.y
	        .if (eax)
	        	invoke SendMessage,hIDC_STC19,WM_SETTEXT,0,ADDR GotItCombo
	        	inc flgFound
			.endif
		.endif

		.if flgFound == 0
        	invoke SendMessage,hIDC_STC19,WM_SETTEXT,0,ADDR CrLf
        .endif
	
	.elseif eax==WM_CLOSE
		invoke DestroyWindow,hWin
	.elseif uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.else

	;Comment the following line out and the ComboBox doesn't report mousemove message !!!!
		PrintText "Som'it else message !"
	
		invoke DefWindowProc,hWin,uMsg,wParam,lParam
		ret
	.endif
	xor    eax,eax
	ret

WndProc endp

end start
